define("customPicaxeBasic_a4", [
  "blocklylib"
  ,"./blockly/generators/picaxebasic"
  ,"./blockly/msg"
], function (BlocklyLib, generators, msg) {


//READ VOLTAGE : Loupiot
generators['picaxe_a4_loupiot_voltage'] = function (block) {
    var voltageLoupiot = generators.variableDB_.getName(block.getFieldValue("NAME"), BlocklyLib.Variables.NAME_TYPE);
    var code = "\treadadc B.5, " + voltageLoupiot + "\n";
    return generators.wrapOutput(block, code);
  };

//BLUETOOTH RX: 
generators['picaxe_a4_bluetooth_rx'] = function (block) {   
    if (!generators.definitions_['a4_define_bluetooth']) generators.definitions_['a4_define_bluetooth'] = '#ifdef _28X2 ;\n\thsersetup B9600_8, %001\n#else\n\thsersetup B9600_4, %000\n#endif\n';
    var name = generators.variableDB_.getName(block.getFieldValue("NAME"), BlocklyLib.Variables.NAME_TYPE);
    var code = "#ifdef _28X2 ;\n\tif hserflag = 1 then\n\t\tdo\n\t\t\tlet "
    code += name + " = @ptrinc\n\t\tloop while ptr <> hserptr\n\t\tlet hserflag = 0\n\telse\n\t\tlet "
    code += name + " = 0\n\tend if\n";
    code += "#else\n\thserin " + name + "\n#endif\n";
    return generators.wrapOutput(block, code);
  };

//BLUETOOTH TX: 
generators['picaxe_a4_bluetooth_tx'] = function (block) {
    if (!generators.definitions_['a4_define_bluetooth']) generators.definitions_['a4_define_bluetooth'] = '#ifdef _28X2 ;\n\thsersetup B9600_8, %001\n#else\n\thsersetup B9600_4, %000\n#endif\n';
    var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
    if (!value) value = 0;
    var code = "\thserout 0, ( " + value + " )\n";
    code += "\tpause 10\n";
    return generators.wrapOutput(block, code);
  };

//MOTOR CONTROL: portal
generators['picaxe_a4_portal'] = function (block) {
  var dirPortal = {
    "OPEN": "high B.7 : low B.6",
    "CLOSE": "low B.7 : high B.6",
    "STOP": "low B.7, B.6"
  };
  var code = "\t" + dirPortal[block.getFieldValue('DIRECTION')] + "\n";
  return generators.wrapOutput(block, code);
};


});
